Subject: [dhcwg] load balancing RFC - what happens if you insert a new server?

From: "Lisa Guo" <[email-masked]>
Date: Thu, 6 Sep 2001 18:31:04 -0700

Hi,
 
  I was looking for discussion on this on the archive website but
couldn't find any, so if this has been discussed before, I apologize.
 
  The load balancing RFC (3074) describes a hashing algorithm that
is used by servers and relay agents to serve the clients in a
deterministic
way. I assume that the purpose is that the same server always serve
the same client, from the initial discover/offer/request/ack to
subsequent
messages, such as renew, release, etc. What happens if a new server
is added to the pool of servers that share the load? In order to use the
new server, some of the hash bucket should be assigned to this new
server now. But if one does that, messages related to an existing lease
would be forwarded to the new server instead of the one that actually
allocated the IP address in the first place.
 
  Does anyone have a workaround on this?
 
Thanks,
Lisa 
-----------------------
Lisa Guo
Tahoe Networks, Inc.

---

From: "Bernie Volz (EUD)" <[email-masked]>
Date: Thu, 6 Sep 2001 21:21:36 -0500

Hi:

It all depends on how the server works. If the server only applies the load balancing to NEW clients and not to renewals, then there really is no problem. That really was the intent of the protocol. Also, only broadcast packets are an issue as unicast datagrams are set to the server in question.

Section 3 of RFC 3074 says:

   Because DHCP clients use UDP broadcasts to contact DHCP servers, a
   client DHCPDISCOVER message may be received by more than one server.
   All servers receiving such a broadcast may respond to the client,
   letting the client choose which server it will use.

There likely will be a revision of this RFC shortly when the DHCPv6 DUID is defined to support load balancing for DHCP for IPv6 as well. Perhaps during that revision (new Internet-Draft), we can be a bit clearer as to the proper use of this.

- Bernie Volz

PS: Note also that for IPv6, while most client generated packets are multicast, the target server is specified when the message is destined for a particular server and that server should process that message regardless of what the load balancing says.

-----Original Message-----
From: Lisa Guo [mailto:[email-masked]]
Sent: Thursday, September 06, 2001 9:31 PM
To: [email-masked]
Subject: [dhcwg] load balancing RFC - what happens if you insert a new server?

Hi,

is used by servers and relay agents to serve the clients in a deterministic
the same client, from the initial discover/offer/request/ack to subsequent

Thanks,
Lisa 
-----------------------
Lisa Guo
Tahoe Networks, Inc.

---

From: "Lisa Guo" <[email-masked]>
Date: Thu, 6 Sep 2001 19:47:44 -0700

-----Original Message-----
From: Bernie Volz (EUD) [mailto:[email-masked]]
Sent: Thursday, September 06, 2001 7:22 PM
To: Lisa Guo; [email-masked]
Subject: RE: [dhcwg] load balancing RFC - what happens if you insert a
new server?

Hi: 

It all depends on how the server works. If the server only applies the
load balancing to NEW clients and not to renewals, then there really is
no problem. That really was the intent of the protocol. Also, only
broadcast packets are an issue as unicast datagrams are set to the
server in question. 

You are right. I missed that part. 

Thanks,

Lisa